<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Channels | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../reference-manual/migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-6-0-2024-12-20">Version 6.0 (2024-12-20)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Tutorial</a> &gt; <span class="breadcrumb">Channels</span>
   </div>
   <h2 id="channels"><a class="anchor" href="#"></a>Channels</h2>
   <div class="paragraph">
    <p>In <a href="processes.html">Processes</a> processes have been introduced. This chapter describes channels, denoted by the type <code>chan</code>. A channel connects two processes and is used for the transfer of data or just signals. One process is the sending process, the other process is the receiving process. Communication between the processes takes place instantly when both processes are willing to communicate, this is called <em>synchronous</em> communication.</p>
   </div>
   <div class="sect3">
    <h3 id="a-channel"><a class="anchor" href="#a-channel"></a>A channel</h3>
    <div class="paragraph">
     <p>The following example shows the sending of an integer value between two processes via a channel. The figure below shows the two processes <code>P</code> and <code>C</code>, connected by channel variable <code>a</code>:</p>
    </div>
    <div id="tut-figure-producer-consumer" class="imageblock">
     <div class="content">
      <img src="pictures/producer_consumer.png" alt="producer consumer">
     </div>
    </div>
    <div class="paragraph">
     <p>Processes are denoted by circles, and channels are denoted by directed arrows in the figure. The arrow denotes the direction of communication. Process <code>P</code> is the sender or producer, process <code>C</code> is the receiver or consumer.</p>
    </div>
    <div class="paragraph">
     <p>In this case, the producer sends a finite stream of integer values (5 numbers) to the consumer. The consumer receives these values and writes them to the screen. The model is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc P(chan! int a):
    for i in range(5):
        a!i
    end
end

proc C(chan? int b):
    int x;

    while true:
        b?x;
        write("%d\n",x)
    end
end

model M():
    chan int a;

    run P(a), C(a)
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The model instantiates processes <code>P</code> and <code>C</code>. The two processes are connected to each other via channel variable <code>a</code> which is given as actual parameter in the <code>run</code> statement. This value is copied into the local formal parameter <code>a</code> in process <code>P</code> and in formal parameter <code>b</code> inside process <code>C</code>.</p>
    </div>
    <div class="paragraph">
     <p>Process <code>P</code> can send a value of type <code>int</code> via the actual channel parameter <code>a</code> to process <code>C</code>. In this case <code>P</code> first tries to send the value <code>0</code>. Process <code>C</code> tries to receive a value of type <code>int</code> via the actual channel parameter <code>a</code>. Both processes can communicate, so the communication occurs and the value <code>0</code> is sent to process <code>C</code>. The received value is assigned in process <code>C</code> to variable <code>x</code>. The value of <code>x</code> is printed and the cycle starts again. This model writes the sequence <code>0, 1, 2, 3, 4</code> to the screen.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="synchronization-channels"><a class="anchor" href="#synchronization-channels"></a>Synchronization channels</h3>
    <div class="paragraph">
     <p>Above, process <code>P</code> constructs the numbers and sends them to process <code>C</code>. However, since it is known that the number sequence starts at <code>0</code> and increments by one each time, there is no actual need to transfer a number. Process <code>C</code> could also construct the number by itself after getting a signal (a 'go ahead') from process <code>P</code>. Such signals are called synchronization signals, transfered by means of a synchronization channel. The signal does not carry any data, it just synchronizes a send and a receive between different processes. (Since there is no actual data transfered, the notion of sender and receiver is ambiguous. However, in modeling there is often a notion of 'initiator' process that can be conveniently expressed with sending.)</p>
    </div>
    <div class="paragraph">
     <p>The following example shows the use of synchronization signals between processes <code>P</code> and <code>C</code>. The connecting channel 'transfers' values of type <code>void</code>. The type <code>void</code> means that 'non-values' are sent and received; the type <code>void</code> is only allowed in combination with channels. The iconic model is given in the previous figure, at the start of this chapter. The model is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc P(chan! void a):
    for i in range(5):
        a!    # No data is being sent
    end
end

proc C(chan? void b):
    int i;

    while true:
        b?;   # Nothing is being received
        write("%d\n", i);
        i = i + 1
    end
end

model M():
    chan void a;

    run P(a), C(a)
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Process <code>P</code> sends a signal (and no value is sent), and process <code>C</code> receives a signal (without a value). The signal is used by process <code>C</code> to write the value of <code>i</code> and to increment variable <code>i</code>. The effect of the model is identical to the previous example: the numbers <code>0, 1, 2, 3, 4</code> appear on the screen.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="two-channels"><a class="anchor" href="#two-channels"></a>Two channels</h3>
    <div class="paragraph">
     <p>A process can have more than one channel, allowing interaction with several other processes.</p>
    </div>
    <div class="paragraph">
     <p>The next example shows two channel variables, <code>a</code> and <code>b</code>, and three processes, generator <code>G</code>, server <code>S</code> and exit <code>E</code>. The iconic model is given below:</p>
    </div>
    <div id="tut-figure-generator-server-exit" class="imageblock">
     <div class="content">
      <img src="pictures/generator_server_exit.png" alt="generator server exit">
     </div>
    </div>
    <div class="paragraph">
     <p>Process <code>G</code> is connected via channel variable <code>a</code> to process <code>S</code> and process <code>S</code> is connected via channel variable <code>b</code> to process <code>E</code>. The model is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc G(chan! int a):
    for x in range(5):
        a!x
    end
end

proc S(chan? int a; chan! int b):
    int x;

    while true:
        a?x; x = 2 * x; b!x
    end
end

proc E(chan int a):
    int x;

    while true:
        a?x;
        write("E %d\n", x)
    end
end

model M():
    chan int a,b;

    run G(a), S(a,b), E(b)
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The model contains two channel variables <code>a</code> and <code>b</code>. The processes are connected to each other in model <code>M</code>. The processes are instantiated and run where the formal parameters are replaced by the actual parameters. Process <code>G</code> sends a stream of integer values <code>0, 1, 2, 3, 4</code> to another process via channel <code>a</code>. Process <code>S</code> receives a value via channel <code>a</code>, assigns this value to variable <code>x</code>, doubles the value of the variable, and sends the value of the variable via <code>b</code> to another process. Process <code>E</code> receives a value via channel <code>b</code>, assigns this value to the variable <code>x</code>, and prints this value. The result of the model is given by:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-console hljs" data-lang="console">E   0
E   2
E   4
E   6
E   8</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>After printing this five lines, process <code>G</code> stops, process <code>S</code> is blocked, as well as process <code>E</code>, the model gets blocked, and the model ends.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="more-senders-or-receivers"><a class="anchor" href="#more-senders-or-receivers"></a>More senders or receivers</h3>
    <div class="paragraph">
     <p>Channels send a message (or a signal in case of synchronization channels) from one sender to one receiver. It is however allowed to give the same channel to several sender or receiver processes. The channel selects a sender and a receiver before each communication.</p>
    </div>
    <div class="paragraph">
     <p>The following example gives an illustration:</p>
    </div>
    <div id="tut-figure-generator-2servers-exit" class="imageblock">
     <div class="content">
      <img src="pictures/generator_2servers_exit.png" alt="generator 2servers exit">
     </div>
    </div>
    <div class="paragraph">
     <p>Suppose that only <code>G</code> and <code>S0</code> want to communicate. The channel can select a sender (namely <code>G</code>) and a receiver (process <code>S0</code>), and let both processes communicate with each other. When sender <code>G</code>, and both receivers (<code>S0</code> and <code>S1</code>), want to communicate, the channel selects a sender (<code>G</code> as it is the only sender available to the channel), and a receiver (either process <code>S0</code> or process <code>S1</code>), and it lets the selected processes communicate with each other. This selection process is non-deterministic; a choice is made, but it is unknown how the selection takes place and it cannot be influenced. Note that a non-deterministic choice is different from a random choice. In the latter case, there are known probabilities of selecting a process.</p>
    </div>
    <div class="paragraph">
     <p>Sharing a channel in this way allows to send data to receiving processes where the receiving party is not relevant (either server process will do). This way of communication is different from <em>broadcasting</em>, where both servers receive the same data value. Broadcasting is not supported by the Chi language.</p>
    </div>
    <div class="paragraph">
     <p>In case of two senders, <code>S0</code> and <code>S1</code>, and one receiver <code>E</code> the selection process is the same. If one of the two servers <code>S</code> can communicate with exit <code>E</code>, communication between that server and the exit takes place. If both servers can communicate, a non-deterministic choice is made.</p>
    </div>
    <div class="paragraph">
     <p>Having several senders and several receivers for a single channel is also handled in the same manner. A non-deterministic choice is made for the sending process and a non-deterministic choice is made for the receiving process before each communication.</p>
    </div>
    <div class="paragraph">
     <p>To communicate with several other processes but without non-determinism, unique channels must be used.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="notes"><a class="anchor" href="#notes"></a>Notes</h3>
    <div class="ulist">
     <ul>
      <li>
       <p>The direction in channels, denoted by <code>?</code> or <code>!</code>, may be omitted. By leaving it out, the semantics of the parameters becomes less clear (the direction of communication has to be derived from the process code).</p></li>
      <li>
       <p>There are a several ways to name channels:</p>
       <div class="olist loweralpha">
        <ol class="loweralpha" type="a">
         <li>
          <p>Start naming formal channel parameters in each new process with <code>a</code>, <code>b</code>, etc. The actual names follow from the figure. This convention is followed in this chapter. For small models this convention is easy and works well, for complicated models this convention can be error-prone.</p></li>
         <li>
          <p>Use the actual names of the channel parameters in the figures as formal names in the processes. Start naming in figures with <code>a</code>, <code>b</code>, etc. This convention works well, if both figure and code are at hand during the design process. If many processes have sub-processes, this convention does not really work.</p></li>
         <li>
          <p>Use unique names for the channel parameters for the whole model, and for all sub-systems, for example a channel between processes <code>A</code> and <code>B</code> is named <code>a2b</code> (the lower-case name of the sending process, followed by <code>2</code>, denoting 'to', and the lower-case name of the receiving process).</p>
          <div class="paragraph">
           <p>In this case the formal and actual parameters can be in most cases the same. If many identical processes are used, this convention does not really work.</p>
          </div></li>
        </ol>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>In the text all three conventions are used, depending on the structure of the model.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="exercises"><a class="anchor" href="#exercises"></a>Exercises</h3>
    <div class="olist arabic">
     <ol class="arabic">
      <li>
       <p>Given is the specification of process <code>P</code> and model <code>PP</code>:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc P(chan int a, b):
    int x;

    while true:
        a?x;
        x = x + 1;
        write("%d\n", x);
        b!x
    end
end

model PP():
    chan int a, b;

    run P(a,b), P(b,a)
end</code></pre>
        </div>
       </div>
       <div class="olist loweralpha">
        <ol class="loweralpha" type="a">
         <li>
          <p>Study this specification.</p></li>
         <li>
          <p>Why does the model terminate immediately?</p></li>
        </ol>
       </div></li>
      <li>
       <p>Six children have been given the assignment to perform a series of calculations on the numbers <code>0, 1, 2, 3, ..., 9</code>, namely add 2, multiply by 3, multiply by 2, and add 6 subsequently. They decide to split up the calculations and to operate in parallel. They sit down at a table next to each other. The first child, the reader <code>R</code>, reads the numbers <code>0, 1, 2, 3, ..., 9</code> one by one to the first calculating child <code>C1</code>. Child <code>C1</code> adds 2 and tells the result to its right neighbour, child <code>C2</code>. After telling the result to child <code>C2</code>, child <code>C1</code> is able to start calculating on the next number the reader <code>R</code> tells him. Children <code>C2</code>, <code>C3</code>, and <code>C4</code> are analogous to child <code>C1</code>; they each perform a different calculation on a number they hear and tell the result to their right neighbor. At the end of the table the writer <code>W</code> writes every result he hears down on paper. A schematic drawing of the children at the table, is given below:</p>
       <div id="tut-figure-sixchilds" class="imageblock">
        <div class="content">
         <img src="pictures/sixchilds.png" alt="sixchilds">
        </div>
       </div>
       <div class="olist loweralpha">
        <ol class="loweralpha" type="a">
         <li>
          <p>Finish the specification for the reading child <code>R</code>, that reads the numbers 0 till 9 one by one:</p>
          <div class="listingblock">
           <div class="content">
            <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc R(...):
    int i;

    while i &lt; 10:
        ...;
        ...
    end
end</code></pre>
           </div>
          </div></li>
         <li>
          <p>Specify the parameterized process <code>Cadd</code> that represents the children <code>C1</code> and <code>C4</code>, who perform an addition.</p></li>
         <li>
          <p>Specify the parameterized process <code>Cmul</code> that represents the children <code>C2</code> and <code>C3</code>, who perform a multiplication.</p></li>
         <li>
          <p>Specify the process <code>W</code> representing the writing child. Write each result to the screen separated by a new line.</p></li>
         <li>
          <p>Make a graphical representation of the model <code>SixChildren</code> that is composed of the six children.</p></li>
         <li>
          <p>Specify the model <code>SixChildren</code>. Simulate the model.</p></li>
        </ol>
       </div></li>
     </ol>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>